/**
 * Autogenerated by Thrift Compiler (0.17.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.example.com.baeldung.thrift.impl;

import javax.annotation.processing.Generated;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@Generated(value = "Autogenerated by Thrift Compiler (0.17.0)", date = "2022-12-17")
public class Workload implements org.apache.thrift.TBase<Workload, Workload._Fields>, java.io.Serializable, Cloneable, Comparable<Workload> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("Workload");

  private static final org.apache.thrift.protocol.TField ROW_PROGRESS_FIELD_DESC = new org.apache.thrift.protocol.TField("rowProgress", org.apache.thrift.protocol.TType.I32, (short)1);
  private static final org.apache.thrift.protocol.TField COL_PROGRESS_FIELD_DESC = new org.apache.thrift.protocol.TField("colProgress", org.apache.thrift.protocol.TType.I32, (short)2);
  private static final org.apache.thrift.protocol.TField MATRIX_ROW_FIELD_DESC = new org.apache.thrift.protocol.TField("matrixRow", org.apache.thrift.protocol.TType.LIST, (short)3);
  private static final org.apache.thrift.protocol.TField MATRIX_COLUMN_FIELD_DESC = new org.apache.thrift.protocol.TField("matrixColumn", org.apache.thrift.protocol.TType.LIST, (short)4);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new WorkloadStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new WorkloadTupleSchemeFactory();

  public int rowProgress; // required
  public int colProgress; // required
  public @org.apache.thrift.annotation.Nullable java.util.List<java.lang.Double> matrixRow; // required
  public @org.apache.thrift.annotation.Nullable java.util.List<java.lang.Double> matrixColumn; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    ROW_PROGRESS((short)1, "rowProgress"),
    COL_PROGRESS((short)2, "colProgress"),
    MATRIX_ROW((short)3, "matrixRow"),
    MATRIX_COLUMN((short)4, "matrixColumn");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // ROW_PROGRESS
          return ROW_PROGRESS;
        case 2: // COL_PROGRESS
          return COL_PROGRESS;
        case 3: // MATRIX_ROW
          return MATRIX_ROW;
        case 4: // MATRIX_COLUMN
          return MATRIX_COLUMN;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    @Override
    public short getThriftFieldId() {
      return _thriftId;
    }

    @Override
    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __ROWPROGRESS_ISSET_ID = 0;
  private static final int __COLPROGRESS_ISSET_ID = 1;
  private byte __isset_bitfield = 0;
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.ROW_PROGRESS, new org.apache.thrift.meta_data.FieldMetaData("rowProgress", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32)));
    tmpMap.put(_Fields.COL_PROGRESS, new org.apache.thrift.meta_data.FieldMetaData("colProgress", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32)));
    tmpMap.put(_Fields.MATRIX_ROW, new org.apache.thrift.meta_data.FieldMetaData("matrixRow", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE))));
    tmpMap.put(_Fields.MATRIX_COLUMN, new org.apache.thrift.meta_data.FieldMetaData("matrixColumn", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE))));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(Workload.class, metaDataMap);
  }

  public Workload() {
  }

  public Workload(
    int rowProgress,
    int colProgress,
    java.util.List<java.lang.Double> matrixRow,
    java.util.List<java.lang.Double> matrixColumn)
  {
    this();
    this.rowProgress = rowProgress;
    setRowProgressIsSet(true);
    this.colProgress = colProgress;
    setColProgressIsSet(true);
    this.matrixRow = matrixRow;
    this.matrixColumn = matrixColumn;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Workload(Workload other) {
    __isset_bitfield = other.__isset_bitfield;
    this.rowProgress = other.rowProgress;
    this.colProgress = other.colProgress;
    if (other.isSetMatrixRow()) {
      java.util.List<java.lang.Double> __this__matrixRow = new java.util.ArrayList<java.lang.Double>(other.matrixRow);
      this.matrixRow = __this__matrixRow;
    }
    if (other.isSetMatrixColumn()) {
      java.util.List<java.lang.Double> __this__matrixColumn = new java.util.ArrayList<java.lang.Double>(other.matrixColumn);
      this.matrixColumn = __this__matrixColumn;
    }
  }

  @Override
  public Workload deepCopy() {
    return new Workload(this);
  }

  @Override
  public void clear() {
    setRowProgressIsSet(false);
    this.rowProgress = 0;
    setColProgressIsSet(false);
    this.colProgress = 0;
    this.matrixRow = null;
    this.matrixColumn = null;
  }

  public int getRowProgress() {
    return this.rowProgress;
  }

  public Workload setRowProgress(int rowProgress) {
    this.rowProgress = rowProgress;
    setRowProgressIsSet(true);
    return this;
  }

  public void unsetRowProgress() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __ROWPROGRESS_ISSET_ID);
  }

  /** Returns true if field rowProgress is set (has been assigned a value) and false otherwise */
  public boolean isSetRowProgress() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __ROWPROGRESS_ISSET_ID);
  }

  public void setRowProgressIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __ROWPROGRESS_ISSET_ID, value);
  }

  public int getColProgress() {
    return this.colProgress;
  }

  public Workload setColProgress(int colProgress) {
    this.colProgress = colProgress;
    setColProgressIsSet(true);
    return this;
  }

  public void unsetColProgress() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __COLPROGRESS_ISSET_ID);
  }

  /** Returns true if field colProgress is set (has been assigned a value) and false otherwise */
  public boolean isSetColProgress() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __COLPROGRESS_ISSET_ID);
  }

  public void setColProgressIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __COLPROGRESS_ISSET_ID, value);
  }

  public int getMatrixRowSize() {
    return (this.matrixRow == null) ? 0 : this.matrixRow.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<java.lang.Double> getMatrixRowIterator() {
    return (this.matrixRow == null) ? null : this.matrixRow.iterator();
  }

  public void addToMatrixRow(double elem) {
    if (this.matrixRow == null) {
      this.matrixRow = new java.util.ArrayList<java.lang.Double>();
    }
    this.matrixRow.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<java.lang.Double> getMatrixRow() {
    return this.matrixRow;
  }

  public Workload setMatrixRow(@org.apache.thrift.annotation.Nullable java.util.List<java.lang.Double> matrixRow) {
    this.matrixRow = matrixRow;
    return this;
  }

  public void unsetMatrixRow() {
    this.matrixRow = null;
  }

  /** Returns true if field matrixRow is set (has been assigned a value) and false otherwise */
  public boolean isSetMatrixRow() {
    return this.matrixRow != null;
  }

  public void setMatrixRowIsSet(boolean value) {
    if (!value) {
      this.matrixRow = null;
    }
  }

  public int getMatrixColumnSize() {
    return (this.matrixColumn == null) ? 0 : this.matrixColumn.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<java.lang.Double> getMatrixColumnIterator() {
    return (this.matrixColumn == null) ? null : this.matrixColumn.iterator();
  }

  public void addToMatrixColumn(double elem) {
    if (this.matrixColumn == null) {
      this.matrixColumn = new java.util.ArrayList<java.lang.Double>();
    }
    this.matrixColumn.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<java.lang.Double> getMatrixColumn() {
    return this.matrixColumn;
  }

  public Workload setMatrixColumn(@org.apache.thrift.annotation.Nullable java.util.List<java.lang.Double> matrixColumn) {
    this.matrixColumn = matrixColumn;
    return this;
  }

  public void unsetMatrixColumn() {
    this.matrixColumn = null;
  }

  /** Returns true if field matrixColumn is set (has been assigned a value) and false otherwise */
  public boolean isSetMatrixColumn() {
    return this.matrixColumn != null;
  }

  public void setMatrixColumnIsSet(boolean value) {
    if (!value) {
      this.matrixColumn = null;
    }
  }

  @Override
  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case ROW_PROGRESS:
      if (value == null) {
        unsetRowProgress();
      } else {
        setRowProgress((java.lang.Integer)value);
      }
      break;

    case COL_PROGRESS:
      if (value == null) {
        unsetColProgress();
      } else {
        setColProgress((java.lang.Integer)value);
      }
      break;

    case MATRIX_ROW:
      if (value == null) {
        unsetMatrixRow();
      } else {
        setMatrixRow((java.util.List<java.lang.Double>)value);
      }
      break;

    case MATRIX_COLUMN:
      if (value == null) {
        unsetMatrixColumn();
      } else {
        setMatrixColumn((java.util.List<java.lang.Double>)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  @Override
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case ROW_PROGRESS:
      return getRowProgress();

    case COL_PROGRESS:
      return getColProgress();

    case MATRIX_ROW:
      return getMatrixRow();

    case MATRIX_COLUMN:
      return getMatrixColumn();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  @Override
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case ROW_PROGRESS:
      return isSetRowProgress();
    case COL_PROGRESS:
      return isSetColProgress();
    case MATRIX_ROW:
      return isSetMatrixRow();
    case MATRIX_COLUMN:
      return isSetMatrixColumn();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that instanceof Workload)
      return this.equals((Workload)that);
    return false;
  }

  public boolean equals(Workload that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_rowProgress = true;
    boolean that_present_rowProgress = true;
    if (this_present_rowProgress || that_present_rowProgress) {
      if (!(this_present_rowProgress && that_present_rowProgress))
        return false;
      if (this.rowProgress != that.rowProgress)
        return false;
    }

    boolean this_present_colProgress = true;
    boolean that_present_colProgress = true;
    if (this_present_colProgress || that_present_colProgress) {
      if (!(this_present_colProgress && that_present_colProgress))
        return false;
      if (this.colProgress != that.colProgress)
        return false;
    }

    boolean this_present_matrixRow = true && this.isSetMatrixRow();
    boolean that_present_matrixRow = true && that.isSetMatrixRow();
    if (this_present_matrixRow || that_present_matrixRow) {
      if (!(this_present_matrixRow && that_present_matrixRow))
        return false;
      if (!this.matrixRow.equals(that.matrixRow))
        return false;
    }

    boolean this_present_matrixColumn = true && this.isSetMatrixColumn();
    boolean that_present_matrixColumn = true && that.isSetMatrixColumn();
    if (this_present_matrixColumn || that_present_matrixColumn) {
      if (!(this_present_matrixColumn && that_present_matrixColumn))
        return false;
      if (!this.matrixColumn.equals(that.matrixColumn))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + rowProgress;

    hashCode = hashCode * 8191 + colProgress;

    hashCode = hashCode * 8191 + ((isSetMatrixRow()) ? 131071 : 524287);
    if (isSetMatrixRow())
      hashCode = hashCode * 8191 + matrixRow.hashCode();

    hashCode = hashCode * 8191 + ((isSetMatrixColumn()) ? 131071 : 524287);
    if (isSetMatrixColumn())
      hashCode = hashCode * 8191 + matrixColumn.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(Workload other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.compare(isSetRowProgress(), other.isSetRowProgress());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRowProgress()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.rowProgress, other.rowProgress);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.compare(isSetColProgress(), other.isSetColProgress());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetColProgress()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.colProgress, other.colProgress);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.compare(isSetMatrixRow(), other.isSetMatrixRow());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMatrixRow()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.matrixRow, other.matrixRow);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.compare(isSetMatrixColumn(), other.isSetMatrixColumn());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMatrixColumn()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.matrixColumn, other.matrixColumn);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  @Override
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  @Override
  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  @Override
  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("Workload(");
    boolean first = true;

    sb.append("rowProgress:");
    sb.append(this.rowProgress);
    first = false;
    if (!first) sb.append(", ");
    sb.append("colProgress:");
    sb.append(this.colProgress);
    first = false;
    if (!first) sb.append(", ");
    sb.append("matrixRow:");
    if (this.matrixRow == null) {
      sb.append("null");
    } else {
      sb.append(this.matrixRow);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("matrixColumn:");
    if (this.matrixColumn == null) {
      sb.append("null");
    } else {
      sb.append(this.matrixColumn);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class WorkloadStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    @Override
    public WorkloadStandardScheme getScheme() {
      return new WorkloadStandardScheme();
    }
  }

  private static class WorkloadStandardScheme extends org.apache.thrift.scheme.StandardScheme<Workload> {

    @Override
    public void read(org.apache.thrift.protocol.TProtocol iprot, Workload struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // ROW_PROGRESS
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.rowProgress = iprot.readI32();
              struct.setRowProgressIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // COL_PROGRESS
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.colProgress = iprot.readI32();
              struct.setColProgressIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // MATRIX_ROW
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list0 = iprot.readListBegin();
                struct.matrixRow = new java.util.ArrayList<java.lang.Double>(_list0.size);
                double _elem1;
                for (int _i2 = 0; _i2 < _list0.size; ++_i2)
                {
                  _elem1 = iprot.readDouble();
                  struct.matrixRow.add(_elem1);
                }
                iprot.readListEnd();
              }
              struct.setMatrixRowIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // MATRIX_COLUMN
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list3 = iprot.readListBegin();
                struct.matrixColumn = new java.util.ArrayList<java.lang.Double>(_list3.size);
                double _elem4;
                for (int _i5 = 0; _i5 < _list3.size; ++_i5)
                {
                  _elem4 = iprot.readDouble();
                  struct.matrixColumn.add(_elem4);
                }
                iprot.readListEnd();
              }
              struct.setMatrixColumnIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    @Override
    public void write(org.apache.thrift.protocol.TProtocol oprot, Workload struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldBegin(ROW_PROGRESS_FIELD_DESC);
      oprot.writeI32(struct.rowProgress);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(COL_PROGRESS_FIELD_DESC);
      oprot.writeI32(struct.colProgress);
      oprot.writeFieldEnd();
      if (struct.matrixRow != null) {
        oprot.writeFieldBegin(MATRIX_ROW_FIELD_DESC);
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.DOUBLE, struct.matrixRow.size()));
          for (double _iter6 : struct.matrixRow)
          {
            oprot.writeDouble(_iter6);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      if (struct.matrixColumn != null) {
        oprot.writeFieldBegin(MATRIX_COLUMN_FIELD_DESC);
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.DOUBLE, struct.matrixColumn.size()));
          for (double _iter7 : struct.matrixColumn)
          {
            oprot.writeDouble(_iter7);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class WorkloadTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    @Override
    public WorkloadTupleScheme getScheme() {
      return new WorkloadTupleScheme();
    }
  }

  private static class WorkloadTupleScheme extends org.apache.thrift.scheme.TupleScheme<Workload> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, Workload struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetRowProgress()) {
        optionals.set(0);
      }
      if (struct.isSetColProgress()) {
        optionals.set(1);
      }
      if (struct.isSetMatrixRow()) {
        optionals.set(2);
      }
      if (struct.isSetMatrixColumn()) {
        optionals.set(3);
      }
      oprot.writeBitSet(optionals, 4);
      if (struct.isSetRowProgress()) {
        oprot.writeI32(struct.rowProgress);
      }
      if (struct.isSetColProgress()) {
        oprot.writeI32(struct.colProgress);
      }
      if (struct.isSetMatrixRow()) {
        {
          oprot.writeI32(struct.matrixRow.size());
          for (double _iter8 : struct.matrixRow)
          {
            oprot.writeDouble(_iter8);
          }
        }
      }
      if (struct.isSetMatrixColumn()) {
        {
          oprot.writeI32(struct.matrixColumn.size());
          for (double _iter9 : struct.matrixColumn)
          {
            oprot.writeDouble(_iter9);
          }
        }
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, Workload struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(4);
      if (incoming.get(0)) {
        struct.rowProgress = iprot.readI32();
        struct.setRowProgressIsSet(true);
      }
      if (incoming.get(1)) {
        struct.colProgress = iprot.readI32();
        struct.setColProgressIsSet(true);
      }
      if (incoming.get(2)) {
        {
          org.apache.thrift.protocol.TList _list10 = iprot.readListBegin(org.apache.thrift.protocol.TType.DOUBLE);
          struct.matrixRow = new java.util.ArrayList<java.lang.Double>(_list10.size);
          double _elem11;
          for (int _i12 = 0; _i12 < _list10.size; ++_i12)
          {
            _elem11 = iprot.readDouble();
            struct.matrixRow.add(_elem11);
          }
        }
        struct.setMatrixRowIsSet(true);
      }
      if (incoming.get(3)) {
        {
          org.apache.thrift.protocol.TList _list13 = iprot.readListBegin(org.apache.thrift.protocol.TType.DOUBLE);
          struct.matrixColumn = new java.util.ArrayList<java.lang.Double>(_list13.size);
          double _elem14;
          for (int _i15 = 0; _i15 < _list13.size; ++_i15)
          {
            _elem14 = iprot.readDouble();
            struct.matrixColumn.add(_elem14);
          }
        }
        struct.setMatrixColumnIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

